import javax.crypto.Cipher;
import javax.crypto.SecretKey;

import javax.crypto.SecretKey;
import javax.crypto.KeyGenerator;

import java.security.Security;


public class IntegrityDemo {

      public static final String BLOCK_CIPHER = "DES/ECB/NoPadding";

      private static byte [] encrypt(int mode, byte [] data, SecretKey key)
            throws Exception
      {
            Cipher cphr = Cipher.getInstance(BLOCK_CIPHER);
            cphr.init(mode, key);
            return cphr.doFinal(data);
      }

      public static String hexEncode(byte [] bytes) {
            StringBuilder sb = new StringBuilder();
            int sz = bytes.length;

            for (int i = 0; i < sz; i++)
                  sb.append(String.format("%02x ", bytes[i]));

            return sb.toString();
      }

      public static void main(String [] args) throws Exception {
            KeyGenerator g = KeyGenerator.getInstance("DES");
            g.init(56);
            SecretKey k = g.generateKey();

            byte [] data = "01234567".getBytes("UTF-8");
            System.out.println("                   plaintext  " + hexEncode(data));

            byte [] cphrTxt = encrypt(Cipher.ENCRYPT_MODE, data, k);
            System.out.println("                  ciphertext  " + hexEncode(cphrTxt));

            byte [] plnTxt = encrypt(Cipher.DECRYPT_MODE, cphrTxt, k);
            System.out.println("        decrypted ciphertext  " + hexEncode(plnTxt));

            cphrTxt[0] += 1;
            System.out.println("          mangled ciphertext  " + hexEncode(cphrTxt));

            plnTxt = encrypt(Cipher.DECRYPT_MODE, cphrTxt, k);
            System.out.println("decrypted mangled ciphertext  " + hexEncode(plnTxt));
      }

}

