package securityutils;

/**
 * This Exception class represents problems discovered when unsealing sealed
 * data. This can include an expired seal, an integrity violation, or some
 * cryptographic error (key mismatch, bad padding, et c.).
 */
public class CorruptBlobException extends Exception {
      public static final long serialVersionUID = 0;

      public CorruptBlobException(String message) {
            super(message);
      }

      public CorruptBlobException(Throwable t) {
            super(t);
      }

}
