<?php

require('validator.php');

function validateWow($v) {
      $goodWows = array('what?' => 1, 'yeehaw' => 1, 'no' => 1);
      return validateWhitelist($v, $goodWows);
}

$validators = array( 'userID' => validateUserID, 'wow' => validateWow, 'ipid' => validateIpid );

$_GET = array( 'userID' => '1', 'wow' => 'what?', 'etc.' => '600',
               'ipid' => '1234567890abcdefabcd1234567890abcdefabcd' );

try {
      print("Before validation:\n");
      print_r($_GET);

      print("After validation:\n");
      print_r( validate($_GET, $validators, true) );
}
catch (InvalidKeyException $e) {
      error_log('FAILURE: We got a key for which no validator is installed: ' .
                $e->getMessage() .  "\n");
}
catch (InvalidDataException $e) {
      error_log('FAILURE: We got a key for which the value was invalid: ' .
                $e->getMessage() .  "\n");
}


try {
      print_r( validate($_GET, $validators, false) );
      print("FAILURE: Was able to validate data with no validator function!\n");
}
catch (InvalidKeyException $e) {
      print("Caught expected InvalidKeyException when using tolerant=false.\n");
}


try {
      // https://www.paypal.com/en_US/vhelp/paypalmanager_help/credit_card_numbers.htm
      $testCCs = array(
          '378282246310005', '371449635398431', '378734493671000', '30569309025904',
          '38520000023237', '6011111111111117', '6011000990139424', '3530111333300000',
          '3566002020360505', '5555555555554444', '5105105105105100', '4111111111111111',
          '4012888888881881', '4222222222222'
      );

      foreach ($testCCs as $c)
           validateCreditCardNumber($c);

      print("Valid test credit card numbers all passed.\n");
}
catch (InvalidDataException $e) {
      error_log('We got InvalidDataException for a valid CC#: ' . $e);
}

$testCCs = array('021131111111111299999999999999', '7111311111111112', '000',
                 '(415) 555-DUDE', '1222222222222');

foreach ($testCCs as $c) {
      try {
            validateCreditCardNumber($c);
            error_log('FAILURE: Invalid CC # ' . $c . ' passed!');
      }
      catch (InvalidDataException $e) {
            print('Received expected InvalidDataException for invalid # ' . $c .
                  ': '. $e->getMessage() . "\n");
            continue;
      }
}

?>

